// ------------------------------------------------------------
// The code in this repository code was written by Lee Campbell, as a
// derived work from the original Java by Gil Tene of Azul Systems and
// Michael Barker, and released to the public domain, as explained
// at http://creativecommons.org/publicdomain/zero/1.0/
// ------------------------------------------------------------

// This file isn't generated, but this comment is necessary to exclude it from StyleCop analysis.
// <auto-generated/>

using HdrHistogram.Utilities;

namespace HdrHistogram.Encoding
{
    internal sealed class V0Header : IHeader
    {
        public V0Header(int cookie, ByteBuffer buffer)
        {
            Cookie = cookie;
            NumberOfSignificantValueDigits = buffer.GetInt();
            LowestTrackableUnitValue = buffer.GetLong();
            HighestTrackableValue = buffer.GetLong();
            PayloadLengthInBytes = int.MaxValue;
            IntegerToDoubleValueConversionRatio = 1.0;
            NormalizingIndexOffset = 0;
        }
        public int Cookie { get; }
        public int PayloadLengthInBytes { get; }
        public int NormalizingIndexOffset { get; }
        public int NumberOfSignificantValueDigits { get; }
        public long LowestTrackableUnitValue { get; }
        public long HighestTrackableValue { get; }
        public double IntegerToDoubleValueConversionRatio { get; }
        public int CapacityEstimateExcess => 32;
    }
}